{DK}
unit Reals;

Interface

Type
  TSingle = Record
    case Byte of
    0 : (L : LongInt);
    1 : (Frac, Int : Word);
    2 : (IFrac, IInt : Integer);
  End;

Function MakeSingle(Int, Frac : Word) : LongInt;
Function Add(A, B : LongInt) : LongInt;
Function Mul(A, B : LongInt) : LongInt;
Function IDiv(A, B : LongInt) : LongInt;
Function Int(T : LongInt) : Integer;  Inline($58/$58);
Function Frac(T : LongInt) : Integer; Inline($58/$5A);

Implementation

Function MakeSingle(Int, Frac : Word) : LongInt; Assembler;
Asm
  xor ax, ax
  mov dx, Frac
  mov bx, 10000
  div bx
  mov dx, Int
End;


Function  Add; Assembler; Asm
  mov ax, word ptr [A]
  mov dx, word ptr [A+2]
  add ax, word ptr [B]
  adc dx, word ptr [B+2]
End;

Function Mul;
Begin
  Mul := A * TSingle(B).Frac shr 16 +
         A * TSingle(B).Int;
End;

Function IDiv;
Begin
  IDiv := A div TSingle(B).Frac shr 16 +
          A div TSingle(B).Int;
End;

End.
